Attribute VB_Name = "modLoad"
Option Explicit

Private Declare Function decode_hash_cdkey Lib "libbnet.dll" (ByVal CDKey As String, ByVal ClientToken As Long, ByVal ServerToken As Long, PublicValue As Long, Product As Long, ByVal HashBuffer As String) As Long

Public Sub Main()
    frmMain.Show
    
    ResetArrays
    
    On Error Resume Next
    
    If Not GetAttr(App.Path & "\Sorted\") And vbDirectory Then
        AppendMessage "Creating Sorted DIR..."
        MkDir App.Path & "\Sorted"
    End If
    
    If Not (GetAttr(App.Path & "\libbnet.dll") And vbDirectory) = 0 Then
        AppendMessage "libbnet.dll not found! Unable to test cdkeys!"
        AppendMessage "KeyTest Offline!"
        Exit Sub
    End If
    
    On Error GoTo 0
    
    AppendMessage "KeyTest Online!"
    AppendMessage "Loading CDKeys..."
    
    LoadCDKeys
    
    If Total = 0 Then
        AppendMessage "You have not entered any cdkeys!"
        Exit Sub
    End If
    
    AppendMessage "Removing duplicates..."
    removeDuplicates STARArr
    removeDuplicates W2BNArr
    removeDuplicates D2DVArr
    removeDuplicates D2XPArr
    removeDuplicates WAR3Arr
    removeDuplicates W3XPArr
    
    
    With frmMain
        AddtoList STARArr, .STAR
        .STARLBL = "Starcraft - (" & .STAR.ListCount & ")"
        AppendMessage "Loaded " & .STAR.ListCount & " Starcraft CDKeys"
        
        AddtoList W2BNArr, .W2BN
        .W2BNLBL = "Warcraft II - (" & .W2BN.ListCount & ")"
        AppendMessage "Loaded " & .W2BN.ListCount & " Warcraft II CDKeys"
        
        AddtoList D2DVArr, .D2DV
        .D2DVLBL = "Diablo II - (" & .D2DV.ListCount & ")"
        AppendMessage "Loaded " & .D2DV.ListCount & " Diablo II CDKeys"
        
        AddtoList D2XPArr, .D2XP
        .D2XPLBL = "Diablo II LOD - (" & .D2XP.ListCount & ")"
        AppendMessage "Loaded " & .D2XP.ListCount & " Diablo II LOD CDKeys"
        
        AddtoList WAR3Arr, .WAR3
        .WAR3LBL = "Warcraft III - (" & .WAR3.ListCount & ")"
        AppendMessage "Loaded " & .WAR3.ListCount & " Warcraft III CDKeys"
        
        AddtoList W3XPArr, .W3XP
        .W3XPLBL = "Warcraft III TFT - (" & .W3XP.ListCount & ")"
        AppendMessage "Loaded " & .W3XP.ListCount & " Warcraft III TFT CDKeys"
        
        
        AppendMessage "Sorted " & .STAR.ListCount + .W2BN.ListCount + _
                                  .D2DV.ListCount + .D2XP.ListCount + _
                                  .WAR3.ListCount + .W3XP.ListCount & " CDKeys, but " & Total - .STAR.ListCount + .W2BN.ListCount + _
                                  .D2DV.ListCount + .D2XP.ListCount + _
                                  .WAR3.ListCount + .W3XP.ListCount & " were duplicates!"
    End With
    
    AppendMessage "Saving lists..."
        SaveSTAR
        SaveW2BN
        SaveD2DV
        SaveD2XP
        SaveWAR3
        SaveW3XP
    AppendMessage "Save complete!"
End Sub

Private Sub LoadCDKeys()
    Dim Location    As String
    Dim Source      As String
    Dim STAR        As Long
    Dim W2BN        As Long
    Dim WAR3        As Long
    Dim D2DV        As Long
    Dim D2XP        As Long
    Dim W3XP        As Long
    Dim c           As Long
    Dim Prod        As Long
    Dim Pub         As Long
    Dim Hash        As String * 20
    Location = "\CDKeys.txt"
    
    Open App.Path & Location For Append As #1
    Close #1
    
    Open App.Path & Location For Input As #1
    
        Do While Not EOF(1)
            Line Input #1, Source
            
                If Len(Source) > 0 Then
                    Source = Trim$(Source)
                    Source = UCase$(Split(Source, Space$(1))(0))
                    
                    decode_hash_cdkey Source, 0, 0, Pub, Prod, Hash
                    
                        Select Case Prod
                            Case &H1, &H2, &H17
                                AddtoArray STARArr, Source: STAR = STAR + 1
                            Case &H6, &H18
                                AddtoArray D2DVArr, Source: D2DV = D2DV + 1
                            Case &HA, &H19
                                AddtoArray D2XPArr, Source: D2XP = D2XP + 1
                            Case &H4
                                AddtoArray W2BNArr, Source: W2BN = W2BN + 1
                            Case &HE
                                AddtoArray WAR3Arr, Source: WAR3 = WAR3 + 1
                            Case &H12
                                AddtoArray W3XPArr, Source: W3XP = W3XP + 1
                            Case Else: Invalid = Invalid + 1
                        End Select
                        
                    DoEvents
                    Total = Total + 1
                End If
        Loop
    Close #1
    AppendMessage "Loaded " & Total & " CDKeys"
    AppendMessage "Skiped " & Invalid & " invalid CDKeys..."
    Valid = Total - Invalid
    AppendMessage "Sorting through " & Valid & " valid CDKeys"
End Sub
